var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from 'prop-types';
import Switch from './Switch';
import Redirect from './Redirect';

var spinnerProps = { key: 'ReactRussianRouter/AsyncSwitch/Spinner' };

var AsyncSwitch = function (_Switch) {
    _inherits(AsyncSwitch, _Switch);

    function AsyncSwitch() {
        _classCallCheck(this, AsyncSwitch);

        var _this = _possibleConstructorReturn(this, (AsyncSwitch.__proto__ || Object.getPrototypeOf(AsyncSwitch)).call(this));

        _this.state.isInited = false;
        _this.state.isWaiting = true;
        return _this;
    }

    _createClass(AsyncSwitch, [{
        key: 'render',
        value: function render() {
            var isInited = this.state.isInited;

            if (!isInited && !this.props.spinnerBeforeInit) {
                return null;
            }
            if (!isInited && this.props.spinnerBeforeInit || this.state.isWaiting && this.props.spinnerWhenWaiting) {
                return this.renderComponent(this.props.spinnerComponent, spinnerProps);
            }
            return _get(AsyncSwitch.prototype.__proto__ || Object.getPrototypeOf(AsyncSwitch.prototype), 'render', this).call(this);
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            var loadPayload = this.props.loadPayload;

            if (loadPayload === AsyncSwitch.defaultProps.loadPayload) {
                // eslint-disable-next-line
                console.warn('You didn\'t provide loadPayload function. Most likely it means that you don\'t need AsyncSwitch.');
            }

            this._prevMatchObjects = this.state.matchObjects;
            this._dataMap = new Map();
            this._prevDataMap = this._dataMap;
            this._catchedError = this.props.initialError;
            _get(AsyncSwitch.prototype.__proto__ || Object.getPrototypeOf(AsyncSwitch.prototype), 'componentWillMount', this).call(this);
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            _get(AsyncSwitch.prototype.__proto__ || Object.getPrototypeOf(AsyncSwitch.prototype), 'componentDidUpdate', this).call(this);

            if (this.state.isWaiting) {
                return;
            }

            this._initSwitch();
            var currentMatchObjects = this._getMatchObjects();
            var renderedMatchObjects = this.state.matchObjects;

            if (!renderedMatchObjects.length) {
                // If there are no renderedMatchObjects, don't cache empty array
                return;
            }

            var isError = renderedMatchObjects[0] && renderedMatchObjects[0].hasOwnProperty('error');
            if (isError && this._catchedError) {
                // If error occured, don't cache renderedMatchObjects
                return;
            }

            // Check whether redirect occured or not during rendering
            for (var r = 0, rl = renderedMatchObjects.length; r < rl; r++) {
                if (renderedMatchObjects[r] !== currentMatchObjects[r]) {
                    // If redirect occured, set previous state to avoid content flashes
                    var isInited = !isError || this._prevMatchObjects.length > 0;
                    this._restorePrevState(isInited);
                    return;
                }
            }

            // If rendering has gone without errors, cache renderedMatchObjects
            this._prevMatchObjects = renderedMatchObjects;
            this._catchedError = null;
            var router = this.context.router;

            router.resetRedirectChain();
        }
    }, {
        key: 'componentDidCatch',
        value: function componentDidCatch(error) {
            this._catchedError = error;
            this.state.isWaiting = false;
            _get(AsyncSwitch.prototype.__proto__ || Object.getPrototypeOf(AsyncSwitch.prototype), 'componentDidCatch', this).call(this, error);
        }
    }, {
        key: '_initSwitch',
        value: function _initSwitch() {
            var isInited = true;
            this.setState({ isInited: isInited });
        }
    }, {
        key: '_restorePrevState',
        value: function _restorePrevState(isInited) {
            this._dataMap = this._prevDataMap;
            this.setState({
                isInited: isInited,
                matchObjects: this._prevMatchObjects
            });
        }
    }, {
        key: '_restoreScroll',
        value: function _restoreScroll() {
            if (this.state.isWaiting) {
                return;
            }
            _get(AsyncSwitch.prototype.__proto__ || Object.getPrototypeOf(AsyncSwitch.prototype), '_restoreScroll', this).apply(this, arguments);
        }
    }, {
        key: '_modifyDataMap',
        value: function _modifyDataMap(dataMap, matchObject, mergeObject) {
            var dataObject = dataMap.get(matchObject) || {};
            Object.assign(dataObject, mergeObject);
            dataMap.set(matchObject, dataObject);
        }
    }, {
        key: '_extractPayloadNode',
        value: function _extractPayloadNode(matchObject) {
            if (matchObject.hasOwnProperty('error')) {
                return matchObject.payload;
            }
            return this._dataMap.get(matchObject).payload;
        }
    }, {
        key: '_getNavigationKey',
        value: function _getNavigationKey() {
            var router = this.context.router;

            return router.getNavigationKey();
        }
    }, {
        key: '_initMatchObjects',
        value: function _initMatchObjects(matchObjects, dataMap) {
            var _this2 = this;

            var initialMatchObjects = matchObjects.map(function (matchObject) {
                return _this2._matchObjectToInitial(matchObject, dataMap);
            });
            this._prevDataMap = this._dataMap;
            this._dataMap = dataMap;
            return initialMatchObjects;
        }
    }, {
        key: '_matchObjectToInitial',
        value: function _matchObjectToInitial(matchObject, dataMap) {
            var payload = this.props.initPayload(matchObject);
            this._modifyDataMap(dataMap, matchObject, { payload: payload });
            return matchObject;
        }
    }, {
        key: '_loadMatchObjects',
        value: function _loadMatchObjects(matchObjects, dataMap) {
            var _this3 = this;

            if (!matchObjects.length) {
                return Promise.reject('Switch cannot render matchObjects!');
            }

            var matchObjectPromises = matchObjects.map(function (matchObject) {
                return _this3._matchObjectToPromise(matchObject, dataMap);
            });
            var minWaitTimePromises = [Promise.all(matchObjectPromises)];
            var minWaitTime = +this.props.minWaitTime;
            var minWaitTimer = void 0;
            if (minWaitTime > 0) {
                minWaitTimePromises.push(new Promise(function (resolve, reject) {
                    minWaitTimer = setTimeout(resolve, minWaitTime);
                }));
            }

            var maxWaitTimePromises = [Promise.all(minWaitTimePromises).then(function (_ref) {
                var _ref2 = _slicedToArray(_ref, 2),
                    a = _ref2[0],
                    b = _ref2[1];

                return a;
            })];
            var maxWaitTime = +this.props.maxWaitTime;
            var maxWaitTimer = void 0;
            if (maxWaitTime > 0) {
                maxWaitTimePromises.push(new Promise(function (resolve, reject) {
                    maxWaitTimer = setTimeout(function () {
                        reject('Max waiting time has expired!');
                    }, maxWaitTime);
                }));
            }

            return Promise.race(maxWaitTimePromises).then(function (matchObjects) {
                clearTimeout(minWaitTimer);
                clearTimeout(maxWaitTimer);
                _this3._prevDataMap = _this3._dataMap;
                _this3._dataMap = dataMap;
                return matchObjects;
            }).catch(function (error) {
                clearTimeout(minWaitTimer);
                clearTimeout(maxWaitTimer);
                throw error;
            });
        }
    }, {
        key: '_matchObjectToPromise',
        value: function _matchObjectToPromise(matchObject, dataMap) {
            var _this4 = this;

            return this.props.loadPayload(matchObject).then(function (payload) {
                _this4._modifyDataMap(dataMap, matchObject, { payload: payload });
                return matchObject;
            });
        }
    }, {
        key: '_throwError',
        value: function _throwError() {
            this.state.isWaiting = false;
            this._initSwitch();
            _get(AsyncSwitch.prototype.__proto__ || Object.getPrototypeOf(AsyncSwitch.prototype), '_throwError', this).apply(this, arguments);
        }
    }, {
        key: '_onUriChange',
        value: function _onUriChange() {
            var _this5 = this;

            var matchObjects = this._getMatchObjects().slice(0, Math.max(0, this.props.childLimit)).filter(function (matchObject) {
                return !!matchObject.payload || !!matchObject.error;
            });
            var navigationKey = this._getNavigationKey();

            // Loop below looks for declarative redirects (from routes' table) and executes them

            var _loop = function _loop(matchObject) {
                if (!matchObject.payload || !matchObject.payload.type || matchObject.payload.type !== Redirect) {
                    return 'continue';
                }
                // Emulate react component (instance of Redirect)
                var fakeRedirectInstance = Object.create(Redirect.prototype, {
                    context: { value: _this5.context },
                    props: { value: matchObject.payload.props }
                });
                // Ensure that redirect will be executed after switch is mounted
                _this5.setState({}, function () {
                    fakeRedirectInstance.componentDidMount();
                });
                return {
                    v: void 0
                };
            };

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = matchObjects[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var matchObject = _step.value;

                    var _ret = _loop(matchObject);

                    switch (_ret) {
                        case 'continue':
                            continue;

                        default:
                            if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            var dataMap = new Map();

            if (this.state.isInited || !this.props.initPayload) {
                this._loadMatchObjects(matchObjects, dataMap).then(this._onPayloadResolve.bind(this, navigationKey)).catch(this._onPayloadReject.bind(this, navigationKey));
            }

            var isWaiting = true;
            this.setState({ isWaiting: isWaiting });

            this._emitUriChange(matchObjects);
            var onWaitStart = this.props.onWaitStart;

            var type = 'waitstart';
            onWaitStart && onWaitStart({ type: type, matchObjects: matchObjects });

            if (!this.state.isInited && this.props.initPayload) {
                try {
                    var initialMatchObjects = this._initMatchObjects(matchObjects, dataMap);
                    this.state.isInited = true;
                    this._onPayloadResolve(navigationKey, initialMatchObjects);
                } catch (error) {
                    this._onPayloadReject(navigationKey, error);
                }
            }
        }
    }, {
        key: '_onPayloadResolve',
        value: function _onPayloadResolve(navigationKey, matchObjects) {
            if (navigationKey !== this._getNavigationKey()) {
                return;
            }

            var isWaiting = false;
            this.setState({
                matchObjects: matchObjects,
                isWaiting: isWaiting
            });

            var onWaitEnd = this.props.onWaitEnd;

            var type = 'waitend';
            onWaitEnd && onWaitEnd({ type: type, matchObjects: matchObjects });
        }
    }, {
        key: '_onPayloadReject',
        value: function _onPayloadReject(navigationKey, error) {
            if (navigationKey !== this._getNavigationKey()) {
                return;
            }

            this._catchedError = error;
            this._matchError = (error || '') + '';
            this._throwError();

            var matchObjects = this.state.matchObjects;
            var onWaitEnd = this.props.onWaitEnd;

            var type = 'waitend';
            onWaitEnd && onWaitEnd({ type: type, matchObjects: matchObjects });
        }
    }]);

    return AsyncSwitch;
}(Switch);

export default AsyncSwitch;


AsyncSwitch.propTypes = {
    childLimit: PropTypes.number,
    loadPayload: PropTypes.func.isRequired,
    initPayload: PropTypes.func,
    errorComponent: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    initialError: PropTypes.any,
    spinnerComponent: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    spinnerBeforeInit: PropTypes.bool,
    spinnerWhenWaiting: PropTypes.bool,
    minWaitTime: PropTypes.number,
    maxWaitTime: PropTypes.number,
    onUriChange: PropTypes.func,
    onError: PropTypes.func,
    onWaitStart: PropTypes.func,
    onWaitEnd: PropTypes.func
};

AsyncSwitch.defaultProps = {
    childLimit: 1,
    loadPayload: function loadPayload(matchObject) {
        return Promise.resolve(matchObject.payload);
    },
    minWaitTime: 0,
    maxWaitTime: 60000
};