var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from 'prop-types';
import AsyncSwitch from './AsyncSwitch';

var cssClassName = 'ReactRussianRouter/FetchSwitch/CssNode';
var jsClassName = 'ReactRussianRouter/FetchSwitch/JsNode';

var FetchSwitch = function (_AsyncSwitch) {
    _inherits(FetchSwitch, _AsyncSwitch);

    function FetchSwitch() {
        _classCallCheck(this, FetchSwitch);

        return _possibleConstructorReturn(this, (FetchSwitch.__proto__ || Object.getPrototypeOf(FetchSwitch)).apply(this, arguments));
    }

    _createClass(FetchSwitch, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._cachedCss = {};
            this._cachedJs = {};
            _get(FetchSwitch.prototype.__proto__ || Object.getPrototypeOf(FetchSwitch.prototype), 'componentWillMount', this).call(this);
        }
    }, {
        key: '_extractPayloadProps',
        value: function _extractPayloadProps(matchObject) {
            var payloadProps = _get(FetchSwitch.prototype.__proto__ || Object.getPrototypeOf(FetchSwitch.prototype), '_extractPayloadProps', this).call(this, matchObject);
            var dataObject = this._dataMap.get(matchObject) || {};
            payloadProps.userData = dataObject.userData;
            return payloadProps;
        }
    }, {
        key: '_matchObjectToInitial',
        value: function _matchObjectToInitial(matchObject, dataMap) {
            var userData = void 0;
            if (this.props.initUserData) {
                userData = this.props.initUserData(matchObject);
                this._modifyDataMap(dataMap, matchObject, { userData: userData });
            }
            var payload = this.props.initPayload(matchObject, userData);
            this._modifyDataMap(dataMap, matchObject, { payload: payload });
            return matchObject;
        }
    }, {
        key: '_loadMatchObjects',
        value: function _loadMatchObjects(matchObjects, dataMap) {
            var _this2 = this;

            return _get(FetchSwitch.prototype.__proto__ || Object.getPrototypeOf(FetchSwitch.prototype), '_loadMatchObjects', this).apply(this, arguments).then(function (matchObjects) {
                _this2._appendCss(null, null);
                _this2._appendJs(null, null);

                matchObjects.forEach(function (matchObject) {
                    var dataObject = dataMap.get(matchObject) || {};
                    var userData = dataObject.userData;
                    var cssCode = dataObject.cssCode || null;
                    var jsCode = dataObject.jsCode || null;

                    _this2._appendCss(cssCode, matchObject, userData);
                    _this2._appendJs(jsCode, matchObject, userData);

                    var payload = _this2.props.extractPayload(matchObject, userData);
                    _this2._modifyDataMap(dataMap, matchObject, { payload: payload });
                });
                return matchObjects;
            });
        }
    }, {
        key: '_matchObjectToPromise',
        value: function _matchObjectToPromise(matchObject, dataMap) {
            var _this3 = this;

            var cssCodePromise = this._getCodePromise(matchObject, 'Css');
            var jsCodePromise = this._getCodePromise(matchObject, 'Js');
            var userDataPromise = this._getUserDataPromise(matchObject);

            return Promise.all([cssCodePromise, jsCodePromise, userDataPromise]).then(function (_ref) {
                var _ref2 = _slicedToArray(_ref, 3),
                    cssCode = _ref2[0],
                    jsCode = _ref2[1],
                    userData = _ref2[2];

                _this3._modifyDataMap(dataMap, matchObject, {
                    cssCode: cssCode, jsCode: jsCode, userData: userData
                });
                return matchObject;
            });
        }
    }, {
        key: '_getCodePromise',
        value: function _getCodePromise(matchObject, language) {
            var _this4 = this;

            var pathExtractor = this.props['extract' + language + 'Path'];
            var filePath = void 0;
            if (typeof pathExtractor === 'string') {
                var payload = matchObject.payload;

                payload = (payload || '') + '';
                if (payload) {
                    filePath = pathExtractor.replace(/{payload}/g, payload).replace(/{payload\.abc}/g, payload.toLowerCase()).replace(/{payload\.ABC}/g, payload.toUpperCase()).replace(/{payload\.Abc}/g, payload.substr(0, 1).toUpperCase() + payload.substr(1).toLowerCase());
                }
            } else if (pathExtractor) {
                filePath = pathExtractor(matchObject);
            } else {
                filePath = '';
            }

            var cacheStorage = this['_cached' + language];
            var cacheKey = matchObject.name + '~' + filePath;
            if (cacheStorage.hasOwnProperty(cacheKey)) {
                return Promise.resolve(cacheStorage[cacheKey]);
            }

            var putValueToCache = function putValueToCache(cacheValue) {
                if (_this4.props['cache' + language]) {
                    cacheStorage[cacheKey] = cacheValue;
                }
                return cacheValue;
            };

            var customLoader = this.props['load' + language];
            if (customLoader) {
                return customLoader(matchObject, filePath).then(putValueToCache);
            }

            if (!filePath) {
                return Promise.resolve(null);
            }
            return fetch(filePath).then(function (response) {
                return response.text();
            }).then(putValueToCache);
        }
    }, {
        key: '_getUserDataPromise',
        value: function _getUserDataPromise(matchObject) {
            if (!this.props.loadUserData) {
                return Promise.resolve(null);
            }
            return this.props.loadUserData(matchObject);
        }
    }, {
        key: '_appendCss',
        value: function _appendCss(cssCode, matchObject, userData) {
            var appendCss = this.props.appendCss;

            if (appendCss) {
                return appendCss(cssCode, matchObject, userData);
            }

            if (!matchObject) {
                var prevCssNodes = document.getElementsByClassName(cssClassName);
                [].concat(_toConsumableArray(prevCssNodes)).forEach(function (prevCssNode) {
                    prevCssNode.parentNode.removeChild(prevCssNode);
                });
            }

            if (!cssCode) {
                return;
            }

            var cssNode = document.createElement('style');
            cssNode.className = cssClassName;
            cssNode.innerHTML = cssCode;
            document.head.appendChild(cssNode);
        }
    }, {
        key: '_appendJs',
        value: function _appendJs(jsCode, matchObject, userData) {
            var appendJs = this.props.appendJs;

            if (appendJs) {
                return appendJs(jsCode, matchObject, userData);
            }

            if (!matchObject) {
                var prevJsNodes = document.getElementsByClassName(jsClassName);
                [].concat(_toConsumableArray(prevJsNodes)).forEach(function (prevJsNode) {
                    prevJsNode.parentNode.removeChild(prevJsNode);
                });
            }

            if (!jsCode) {
                return;
            }

            var jsNode = document.createElement('script');
            jsNode.className = jsClassName;
            jsNode.innerHTML = jsCode;
            document.head.appendChild(jsNode);
        }
    }, {
        key: '_throwError',
        value: function _throwError() {
            _get(FetchSwitch.prototype.__proto__ || Object.getPrototypeOf(FetchSwitch.prototype), '_throwError', this).apply(this, arguments);
            var matchObject = this.state.matchObjects[0];
            this._appendJs(null, matchObject);
            this._appendCss(null, matchObject);
        }
    }]);

    return FetchSwitch;
}(AsyncSwitch);

export default FetchSwitch;


FetchSwitch.propTypes = {
    childLimit: PropTypes.number,
    extractPayload: PropTypes.func.isRequired,
    initPayload: PropTypes.func,
    loadUserData: PropTypes.func,
    initUserData: PropTypes.func,
    loadJs: PropTypes.func,
    loadCss: PropTypes.func,
    cacheJs: PropTypes.bool,
    cacheCss: PropTypes.bool,
    extractJsPath: PropTypes.oneOfType([PropTypes.func, PropTypes.string]).isRequired,
    extractCssPath: PropTypes.oneOfType([PropTypes.func, PropTypes.string]).isRequired,
    errorComponent: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    initialError: PropTypes.any,
    spinnerComponent: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    spinnerBeforeInit: PropTypes.bool,
    spinnerWhenWaiting: PropTypes.bool,
    minWaitTime: PropTypes.number,
    maxWaitTime: PropTypes.number,
    onUriChange: PropTypes.func,
    onError: PropTypes.func,
    onWaitStart: PropTypes.func,
    onWaitEnd: PropTypes.func
};

FetchSwitch.defaultProps = {
    childLimit: 1,
    extractPayload: function extractPayload(matchObject) {
        return matchObject.payload;
    },
    extractJsPath: '{payload}.js',
    extractCssPath: '{payload}.css'
};