var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import TransitionSwitch from './TransitionSwitch';

var ProgressSwitch = function (_TransitionSwitch) {
    _inherits(ProgressSwitch, _TransitionSwitch);

    function ProgressSwitch() {
        _classCallCheck(this, ProgressSwitch);

        var _this = _possibleConstructorReturn(this, (ProgressSwitch.__proto__ || Object.getPrototypeOf(ProgressSwitch)).apply(this, arguments));

        _this.state.currentTime = Date.now();
        return _this;
    }

    _createClass(ProgressSwitch, [{
        key: 'renderProcessedChildren',
        value: function renderProcessedChildren(rawChildren, rawKeys) {
            var _this2 = this;

            var processedChildren = [];

            React.Children.forEach(rawChildren, function (child, c) {
                if (!React.isValidElement(child)) {
                    return processedChildren.push(child);
                }
                if (!child.props.matchObject || !child.props.matchObject.name) {
                    return processedChildren.push(React.Children.map(child, function (c) {
                        return c;
                    }));
                }
                var objectKey = rawKeys[c];
                child = React.cloneElement(child, {
                    ref: function ref(component) {
                        return _this2._onChildRef(objectKey, component);
                    },
                    key: objectKey,
                    transitionProgress: _this2._getTransitionProgress(objectKey)
                });
                return processedChildren.push(child);
            });

            return processedChildren;
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _props = this.props,
                progressEasing = _props.progressEasing,
                transitionDuration = _props.transitionDuration;

            if (typeof progressEasing !== 'function' || +progressEasing(0) !== 0 || +progressEasing(100) !== 100) {
                throw new Error('Prop progressEasing must be presented by function that returns 0 for 0, 100 for 100!');
            }
            if (+transitionDuration > 0 === false) {
                throw new Error('Prop transitionDuration must be presented by positive number!');
            }
            _get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), 'componentWillMount', this).call(this);
            this._componentStartTimes = {};
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            var _this3 = this;

            _get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), 'componentDidUpdate', this).call(this);

            var transitionDuration = this.props.transitionDuration;
            var hiddenKeys = this.state.hiddenKeys;

            var currentTime = Date.now();
            var shouldUpdateTime = false;
            for (var objectKey in this._componentStartTimes) {
                var isHidden = hiddenKeys.indexOf(objectKey) !== -1;
                var transitionStartTime = this._componentStartTimes[objectKey];
                if (currentTime - transitionStartTime < transitionDuration) {
                    shouldUpdateTime = true;
                } else if (isHidden) {
                    this._onLeaveComplete(objectKey);
                } else {
                    this._onEnterComplete(objectKey);
                }
            }

            if (!shouldUpdateTime) {
                return;
            }
            cancelAnimationFrame(this._updateAnimationFrame);
            this._updateAnimationFrame = requestAnimationFrame(function () {
                var currentTime = Date.now();
                _this3.setState({ currentTime: currentTime });
            });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            cancelAnimationFrame(this._updateAnimationFrame);
            _get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), 'componentWillUnmount', this).call(this);
        }
    }, {
        key: '_getRawProgress',
        value: function _getRawProgress(objectKey) {
            var transitionDuration = this.props.transitionDuration;

            var transitionStartTime = this._componentStartTimes[objectKey];
            var transitionCurrentTime = this.state.currentTime;
            var rawProgress = Math.max(0, Math.min(100, 100 * (transitionCurrentTime - transitionStartTime) / transitionDuration));
            return rawProgress;
        }
    }, {
        key: '_getTransitionProgress',
        value: function _getTransitionProgress(objectKey) {
            var isHidden = this.state.hiddenKeys.indexOf(objectKey) !== -1;
            var isAnimating = this._componentStartTimes.hasOwnProperty(objectKey);
            var rawProgress = isAnimating ? this._getRawProgress(objectKey) : 100;
            var processedProgress = +this.props.progressEasing(isHidden ? 100 - rawProgress : rawProgress) || 0;
            return processedProgress;
        }
    }, {
        key: '_makeEnter',
        value: function _makeEnter(objectKey, component) {
            component.componentBeforeEnter && component.componentBeforeEnter();
            this._onEnterStart(objectKey);
        }
    }, {
        key: '_makeLeave',
        value: function _makeLeave(objectKey, component) {
            component.componentBeforeLeave && component.componentBeforeLeave();
            this._onLeaveStart(objectKey);
        }
    }, {
        key: '_onUriChange',
        value: function _onUriChange() {
            _get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), '_onUriChange', this).apply(this, arguments);
            var currentTime = Date.now();
            this.setState({ currentTime: currentTime });
        }
    }, {
        key: '_onChildRef',
        value: function _onChildRef() {
            if (!_get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), '_onChildRef', this).apply(this, arguments)) {
                return false;
            }
            var currentTime = Date.now();
            this.setState({ currentTime: currentTime });
            return true;
        }
    }, {
        key: '_onTransitionCallback',
        value: function _onTransitionCallback() {}
    }, {
        key: '_onEnterStart',
        value: function _onEnterStart(objectKey) {
            if (!_get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), '_onEnterStart', this).apply(this, arguments)) {
                return false;
            }
            this._componentStartTimes[objectKey] = Date.now();
            return true;
        }
    }, {
        key: '_onEnterComplete',
        value: function _onEnterComplete(objectKey) {
            this._componentStates[objectKey] = 'enter';
            if (!_get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), '_onEnterComplete', this).apply(this, arguments)) {
                return false;
            }
            delete this._componentStartTimes[objectKey];
            return true;
        }
    }, {
        key: '_onLeaveStart',
        value: function _onLeaveStart(objectKey) {
            if (!_get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), '_onLeaveStart', this).apply(this, arguments)) {
                return false;
            }
            this._componentStartTimes[objectKey] = Date.now();
            return true;
        }
    }, {
        key: '_onLeaveComplete',
        value: function _onLeaveComplete(objectKey) {
            if (!_get(ProgressSwitch.prototype.__proto__ || Object.getPrototypeOf(ProgressSwitch.prototype), '_onLeaveComplete', this).apply(this, arguments)) {
                return false;
            }
            delete this._componentStartTimes[objectKey];
            var currentTime = Date.now();
            this.setState({ currentTime: currentTime });
            return true;
        }
    }]);

    return ProgressSwitch;
}(TransitionSwitch);

export default ProgressSwitch;


ProgressSwitch.propTypes = {
    childLimit: PropTypes.number,
    transitionOnAppear: PropTypes.bool,
    transitionDuration: PropTypes.number,
    progressEasing: PropTypes.func,
    errorComponent: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    initialError: PropTypes.any,
    onUriChange: PropTypes.func,
    onError: PropTypes.func,
    onEnterStart: PropTypes.func,
    onEnterEnd: PropTypes.func,
    onLeaveStart: PropTypes.func,
    onLeaveEnd: PropTypes.func
};

ProgressSwitch.defaultProps = {
    childLimit: 1,
    transitionOnAppear: false,
    transitionDuration: 1000,
    progressEasing: function progressEasing(progress) {
        return progress;
    }
};