var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import UniversalRussianRouter from './UniversalRussianRouter';

var ReactRussianRouter = function (_React$PureComponent) {
    _inherits(ReactRussianRouter, _React$PureComponent);

    function ReactRussianRouter() {
        _classCallCheck(this, ReactRussianRouter);

        return _possibleConstructorReturn(this, (ReactRussianRouter.__proto__ || Object.getPrototypeOf(ReactRussianRouter)).apply(this, arguments));
    }

    _createClass(ReactRussianRouter, [{
        key: 'render',
        value: function render() {
            return this.props.children;
        }
    }, {
        key: 'getChildContext',
        value: function getChildContext() {
            var router = this._router;
            var feedback = this.props.feedback;

            return { router: router, feedback: feedback };
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _props = this.props,
                routes = _props.routes,
                options = _props.options;

            var router = new UniversalRussianRouter(routes, options, this.props.request);
            var redirectChain = [];
            router.resetRedirectChain = function () {
                return redirectChain = [];
            };
            router.getRedirectChain = function () {
                return redirectChain;
            };
            router.increaseRedirectChain = function (uri) {
                return redirectChain.push(uri);
            };

            this._router = router;
            this._onUriChange = this._onUriChange.bind(this);
            this._onUriChange();
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var router = this._router;
            router.addListener('change', this._onUriChange);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var router = this._router;
            router.removeListener('change', this._onUriChange);
            router.destructor();
        }
    }, {
        key: '_onUriChange',
        value: function _onUriChange(event) {
            var router = this._router;
            var matchObjects = router.getMatchObjects();
            this.setState({ matchObjects: matchObjects });

            var onUriChange = this.props.onUriChange;

            event && onUriChange && onUriChange(event);
        }
    }]);

    return ReactRussianRouter;
}(React.PureComponent);

export default ReactRussianRouter;


ReactRussianRouter.childContextTypes = {
    router: PropTypes.instanceOf(UniversalRussianRouter),
    feedback: PropTypes.object
};

ReactRussianRouter.propTypes = {
    routes: PropTypes.objectOf(PropTypes.shape({
        uri: PropTypes.string,
        payload: PropTypes.any,
        params: PropTypes.object,
        options: PropTypes.object
    })),
    options: PropTypes.object,
    request: PropTypes.object,
    feedback: PropTypes.object,
    onUriChange: PropTypes.func
};

ReactRussianRouter.defaultProps = {
    routes: {},
    options: {}
};