var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import UniversalRussianRouter from './UniversalRussianRouter';
import Link from './Link';

var Redirect = function (_React$PureComponent) {
    _inherits(Redirect, _React$PureComponent);

    function Redirect() {
        _classCallCheck(this, Redirect);

        return _possibleConstructorReturn(this, (Redirect.__proto__ || Object.getPrototypeOf(Redirect)).apply(this, arguments));
    }

    _createClass(Redirect, [{
        key: 'render',
        value: function render() {
            return null;
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (typeof window !== 'undefined') {
                return;
            }
            var feedback = this.context.feedback;

            if (!feedback || feedback.redirect) {
                return;
            }
            var uri = this._generateUri();
            feedback.redirect = uri;
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var router = this.context.router;

            var redirectChain = router.getRedirectChain();
            var uri = this._generateUri();

            if (redirectChain.indexOf(uri) !== -1) {
                var redirectError = 'Redirect loop was detected!\n';
                redirectError += redirectChain.join('\n');
                redirectError += '\n' + uri + ' again...';
                throw new Error(redirectError);
            }

            router.increaseRedirectChain(uri);
            if (this.props.action === 'push') {
                router.pushUri(uri);
            } else {
                router.replaceUri(uri);
            }
        }
    }, {
        key: '_generateUri',
        value: function _generateUri() {
            var _Link$prototype$_gene;

            return (_Link$prototype$_gene = Link.prototype._generateUri).call.apply(_Link$prototype$_gene, [this].concat(Array.prototype.slice.call(arguments)));
        }
    }]);

    return Redirect;
}(React.PureComponent);

export default Redirect;


Redirect.contextTypes = {
    router: PropTypes.instanceOf(UniversalRussianRouter),
    feedback: PropTypes.object
};

Redirect.propTypes = {
    href: PropTypes.string,
    name: PropTypes.string,
    params: PropTypes.object,
    action: PropTypes.oneOf(['replace', 'push'])
};

Redirect.defaultProps = {
    action: 'replace'
};