var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import UniversalRussianRouter from './UniversalRussianRouter';

var Switch = function (_React$PureComponent) {
    _inherits(Switch, _React$PureComponent);

    function Switch() {
        _classCallCheck(this, Switch);

        var _this = _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).call(this));

        var matchObjects = [];
        _this.state = { matchObjects: matchObjects };
        return _this;
    }

    _createClass(Switch, [{
        key: 'render',
        value: function render() {
            var matchObjects = this.state.matchObjects;

            return this.renderMatchObjects(matchObjects);
        }
    }, {
        key: 'renderMatchObjects',
        value: function renderMatchObjects(matchObjects) {
            try {
                return this.renderContent(matchObjects);
            } catch (error) {
                return this.renderError(matchObjects, error);
            }
        }
    }, {
        key: 'renderError',
        value: function renderError(matchObjects, error) {
            this._matchError = (error || '') + '';
            // eslint-disable-next-line
            console.error(error);
            return null;
        }
    }, {
        key: 'renderContent',
        value: function renderContent(matchObjects) {
            var _this2 = this;

            var contentNodes = matchObjects.slice(0, Math.max(0, this.props.childLimit)).filter(function (matchObject) {
                return !!matchObject.payload || !!matchObject.error;
            }).map(function (matchObject) {
                return _this2.renderPayload(matchObject);
            });
            if (!contentNodes.length) {
                throw new Error('Switch cannot render matchObjects!');
            }
            return contentNodes;
        }
    }, {
        key: 'renderPayload',
        value: function renderPayload(matchObject) {
            var Payload = this._extractPayloadNode(matchObject);
            var payloadProps = this._extractPayloadProps(matchObject);
            return this.renderComponent(Payload, payloadProps);
        }
    }, {
        key: 'renderComponent',
        value: function renderComponent(Component, props) {
            if (Component instanceof React.Component || typeof Component === 'function') {
                return React.createElement(Component, props);
            } else if (Component === undefined) {
                return null;
            } else if (React.isValidElement(Component)) {
                return React.cloneElement(Component, typeof Component.type === 'string' ? {
                    key: props.key
                } : props);
            } else {
                return Component;
            }
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._errorId = 0;
            this._matchError = (this.props.initialError || '') + '';
            this._onUriChange = this._onUriChange.bind(this);
            if (this._matchError) {
                this._throwError();
            } else {
                this._onUriChange();
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var router = this.context.router;

            router.addListener('change', this._onUriChange);
            this.componentDidUpdate();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (!this._matchError) {
                this._restoreScroll();
                var router = this.context.router;

                router.resetRedirectChain();
                return;
            }
            this._throwError();
        }
    }, {
        key: 'componentDidCatch',
        value: function componentDidCatch(error) {
            this._matchError = (error || '') + '';
            this._throwError();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var router = this.context.router;

            router.removeListener('change', this._onUriChange);
        }
    }, {
        key: '_extractPayloadNode',
        value: function _extractPayloadNode(matchObject) {
            return matchObject.payload;
        }
    }, {
        key: '_extractPayloadProps',
        value: function _extractPayloadProps(matchObject) {
            var key = matchObject.key;

            return { key: key, matchObject: matchObject };
        }
    }, {
        key: '_getMatchObjects',
        value: function _getMatchObjects() {
            var router = this.context.router;

            var matchObjects = router.getMatchObjects();
            return matchObjects;
        }
    }, {
        key: '_restoreScroll',
        value: function _restoreScroll() {
            var router = this.context.router;

            var navigationKey = router.getNavigationKey();
            if (navigationKey !== this._navigationKey) {
                this._navigationKey = navigationKey;
                router.restoreScroll();
            }
        }
    }, {
        key: '_throwError',
        value: function _throwError() {
            var section = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'match';

            var error = this['_' + section + 'Error'];
            var errorName = 'ReactRussianRouter/Switch/Error';
            var errorKey = errorName + '~' + this._errorId++;
            var errorObject = {
                name: errorName,
                key: errorKey,
                payload: this.props.errorComponent,
                data: null,
                error: error
            };

            this['_' + section + 'Error'] = null;
            this.state[section + 'Keys'] = [errorKey];
            this.state[section + 'Objects'] = [errorObject];
            this.forceUpdate();

            var onError = this.props.onError;

            var type = 'error';
            onError && onError({ type: type, error: error, section: section });
        }
    }, {
        key: '_emitUriChange',
        value: function _emitUriChange(matchObjects) {
            var onUriChange = this.props.onUriChange;

            var type = 'urichange';
            onUriChange && onUriChange({ type: type, matchObjects: matchObjects });
        }
    }, {
        key: '_onUriChange',
        value: function _onUriChange() {
            var matchObjects = this._getMatchObjects();
            this.setState({ matchObjects: matchObjects });
            this._emitUriChange(matchObjects);
        }
    }]);

    return Switch;
}(React.PureComponent);

export default Switch;


Switch.contextTypes = {
    router: PropTypes.instanceOf(UniversalRussianRouter).isRequired
};

Switch.propTypes = {
    childLimit: PropTypes.number,
    errorComponent: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    initialError: PropTypes.any,
    onUriChange: PropTypes.func,
    onError: PropTypes.func
};

Switch.defaultProps = {
    childLimit: 1
};