var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import Switch from './Switch';

var TransitionSwitch = function (_Switch) {
    _inherits(TransitionSwitch, _Switch);

    function TransitionSwitch() {
        _classCallCheck(this, TransitionSwitch);

        var _this = _possibleConstructorReturn(this, (TransitionSwitch.__proto__ || Object.getPrototypeOf(TransitionSwitch)).call(this));

        _this.state = {
            matchObjects: [],
            matchKeys: [],
            hiddenObjects: [],
            hiddenKeys: []
        };
        return _this;
    }

    _createClass(TransitionSwitch, [{
        key: 'render',
        value: function render() {
            var _state = this.state,
                matchObjects = _state.matchObjects,
                matchKeys = _state.matchKeys,
                hiddenObjects = _state.hiddenObjects,
                hiddenKeys = _state.hiddenKeys;

            var rawHiddenChildren = this.renderMatchObjects(hiddenObjects);
            var rawMatchChildren = this.renderMatchObjects(matchObjects);
            var processedHiddenChildren = this.renderProcessedChildren(rawHiddenChildren, hiddenKeys);
            var processedMatchChildren = this.renderProcessedChildren(rawMatchChildren, matchKeys);

            return processedHiddenChildren.concat(processedMatchChildren);
        }
    }, {
        key: 'renderProcessedChildren',
        value: function renderProcessedChildren(rawChildren, rawKeys) {
            var _this2 = this;

            var processedChildren = [];

            React.Children.forEach(rawChildren, function (child, c) {
                if (!React.isValidElement(child) || typeof child.type === 'string') {
                    return processedChildren.push(child);
                }
                var childPrototype = child.type.prototype;
                if (!childPrototype.isReactComponent || !child.props.matchObject || !child.props.matchObject.name) {
                    return processedChildren.push(React.Children.map(child, function (c) {
                        return c;
                    }));
                }
                if (!childPrototype.componentBeforeEnter && !childPrototype.componentWillEnter && !childPrototype.componentDidEnter && !childPrototype.componentBeforeLeave && !childPrototype.componentWillLeave && !childPrototype.componentDidLeave) {
                    return processedChildren.push(React.Children.map(child, function (c) {
                        return c;
                    }));
                }
                var objectKey = rawKeys[c];
                child = React.cloneElement(child, {
                    ref: function ref(component) {
                        return _this2._onChildRef(objectKey, component);
                    },
                    key: objectKey
                });
                return processedChildren.push(child);
            });

            return processedChildren;
        }
    }, {
        key: 'renderError',
        value: function renderError(matchObjects, error) {
            if (matchObjects === this.state.matchObjects) {
                this._matchError = (error || '') + '';
            } else {
                this._hiddenError = (error || '') + '';
            }
            // eslint-disable-next-line
            console.error(error);
            return null;
        }
    }, {
        key: 'renderContent',
        value: function renderContent(matchObjects) {
            var _this3 = this;

            var childLimit = matchObjects === this.state.matchObjects ? this.props.childLimit : Infinity;
            var contentNodes = matchObjects.slice(0, Math.max(0, childLimit)).filter(function (matchObject) {
                return !!matchObject.payload || !!matchObject.error;
            }).map(function (matchObject) {
                return _this3.renderPayload(matchObject);
            });

            if (matchObjects === this.state.matchObjects && !contentNodes.length) {
                throw new Error('Switch cannot render matchObjects!');
            }
            return contentNodes;
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._isAnimationEnabled = this.props.transitionOnAppear;
            this._componentRefs = {};
            this._componentStates = {};
            this._componentAnimationFrames = {};
            this._routeIds = {};
            this._callbackTimers = [];
            this._hiddenError = null;

            _get(TransitionSwitch.prototype.__proto__ || Object.getPrototypeOf(TransitionSwitch.prototype), 'componentWillMount', this).call(this);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            _get(TransitionSwitch.prototype.__proto__ || Object.getPrototypeOf(TransitionSwitch.prototype), 'componentDidMount', this).call(this);
            this._animationTimer = setTimeout(this._onAnimationTimerTick.bind(this));
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (!this._matchError && !this._hiddenError) {
                this._restoreScroll();
                return;
            }
            this._errorId++;
            this._matchError && this._throwError('match');
            this._hiddenError && this._throwError('hidden');
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var componentAnimationFrames = this._componentAnimationFrames;
            for (var objectKey in componentAnimationFrames) {
                cancelAnimationFrame(componentAnimationFrames[objectKey]);
            }

            var componentStates = this._componentStates;
            for (var _objectKey in componentStates) {
                var componentState = componentStates[_objectKey];
                if (componentState === 'enter') {
                    this._onEnterComplete(_objectKey);
                } else if (componentState === 'leave') {
                    this._onLeaveComplete(_objectKey);
                }
            }

            clearTimeout(this._animationTimer);
            var callbackTimers = this._callbackTimers;
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = callbackTimers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var callbackTimer = _step.value;

                    clearTimeout(callbackTimer);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            _get(TransitionSwitch.prototype.__proto__ || Object.getPrototypeOf(TransitionSwitch.prototype), 'componentWillUnmount', this).call(this);
        }
    }, {
        key: '_getComponentRef',
        value: function _getComponentRef(objectKey) {
            return this._componentRefs[objectKey];
        }
    }, {
        key: '_setComponentRef',
        value: function _setComponentRef(objectKey, component) {
            this._componentRefs[objectKey] = component;
        }
    }, {
        key: '_makeEnter',
        value: function _makeEnter(objectKey, component) {
            component.isComponentMounted && component.componentBeforeEnter && component.componentBeforeEnter();
            if (component.componentWillEnter) {
                this._componentAnimationFrames[objectKey] = requestAnimationFrame(this._onEnterStart.bind(this, objectKey));
            } else if (component.componentDidEnter) {
                this._componentStates[objectKey] = 'enter';
                this._onEnterComplete(objectKey);
            }
        }
    }, {
        key: '_makeLeave',
        value: function _makeLeave(objectKey, component) {
            this._onEnterComplete(objectKey);
            component.isComponentMounted && component.componentBeforeLeave && component.componentBeforeLeave();
            if (component.componentWillLeave) {
                this._componentAnimationFrames[objectKey] = requestAnimationFrame(this._onLeaveStart.bind(this, objectKey));
            } else {
                this._onLeaveComplete(objectKey);
            }
        }
    }, {
        key: '_onUriChange',
        value: function _onUriChange() {
            var _this4 = this;

            var router = this.context.router;

            var prevMatchObjects = this.state.matchObjects;
            var prevMatchKeys = this.state.matchKeys;
            var prevHiddenObjects = this.state.hiddenObjects;
            var prevHiddenKeys = this.state.hiddenKeys;
            var matchObjects = this._getMatchObjects();
            var matchKeys = [];
            var hiddenObjects = prevHiddenObjects.slice();
            var hiddenKeys = prevHiddenKeys.slice();

            matchObjects.forEach(function (matchObject) {
                var routeName = matchObject.name;
                if (!_this4._routeIds[routeName]) {
                    _this4._routeIds[routeName] = 1;
                }
                var objectIndex = prevMatchObjects.findIndex(function (prevMatchObject) {
                    return prevMatchObject.name === routeName;
                });
                if (objectIndex === -1 || prevMatchObjects[objectIndex].key !== matchObject.key) {
                    matchKeys.push(matchObject.key + '~' + router.getNavigationKey());
                } else {
                    matchKeys.push(prevMatchKeys[objectIndex]);
                }
            });

            prevMatchObjects.forEach(function (prevMatchObject, p) {
                var objectKey = prevMatchKeys[p];
                var objectIndex = matchKeys.indexOf(objectKey);
                if (objectIndex !== -1) {
                    return;
                }
                var component = _this4._getComponentRef(objectKey);
                if (!component) {
                    return;
                }
                hiddenObjects.push(prevMatchObject);
                hiddenKeys.push(objectKey);
                _this4._makeLeave(objectKey, component);
            });

            this.setState({
                matchObjects: matchObjects,
                matchKeys: matchKeys,
                hiddenObjects: hiddenObjects,
                hiddenKeys: hiddenKeys
            });

            this._emitUriChange(matchObjects);
        }
    }, {
        key: '_onChildRef',
        value: function _onChildRef(objectKey, component) {
            if (!component) {
                return false;
            }

            var prevComponent = this._getComponentRef(objectKey);
            if (component !== prevComponent) {
                this._setComponentRef(objectKey, component);
                component.isComponentMounted = true;
                var componentWillUnmount = component.componentWillUnmount;

                component.componentWillUnmount = function () {
                    component.isComponentMounted = false;
                    typeof componentWillUnmount === 'function' && componentWillUnmount.call(component);
                };
            }
            if (prevComponent) {
                return false;
            }

            if (!this._isAnimationEnabled) {
                return false;
            }

            this._makeEnter(objectKey, component);
            return true;
        }
    }, {
        key: '_onAnimationTimerTick',
        value: function _onAnimationTimerTick() {
            this._isAnimationEnabled = true;
        }
    }, {
        key: '_onTransitionCallback',
        value: function _onTransitionCallback(callbackName, objectKey, transitionDuration) {
            if (+transitionDuration > 0) {
                var callbackTimer = setTimeout(this[callbackName].bind(this, objectKey), +transitionDuration);
                this._callbackTimers.push(callbackTimer);
                return callbackTimer;
            } else {
                this[callbackName](objectKey);
            }
        }
    }, {
        key: '_onEnterStart',
        value: function _onEnterStart(objectKey) {
            var component = this._getComponentRef(objectKey);
            if (!component) {
                return false;
            }
            this._componentAnimationFrames[objectKey] = null;
            this._componentStates[objectKey] = 'enter';
            component.isComponentMounted && component.componentWillEnter && component.componentWillEnter(this._onTransitionCallback.bind(this, '_onEnterComplete', objectKey));

            var onEnterStart = this.props.onEnterStart;
            var _state2 = this.state,
                matchObjects = _state2.matchObjects,
                hiddenObjects = _state2.hiddenObjects;

            var type = 'enterstart';
            onEnterStart && onEnterStart({ type: type, component: component, matchObjects: matchObjects, hiddenObjects: hiddenObjects });
            return true;
        }
    }, {
        key: '_onEnterComplete',
        value: function _onEnterComplete(objectKey) {
            var component = this._getComponentRef(objectKey);
            if (!component) {
                return false;
            }
            if (this._componentStates[objectKey] !== 'enter') {
                return false;
            }
            this._componentStates[objectKey] = null;
            component.isComponentMounted && component.componentDidEnter && component.componentDidEnter();

            var onEnterEnd = this.props.onEnterEnd;
            var _state3 = this.state,
                matchObjects = _state3.matchObjects,
                hiddenObjects = _state3.hiddenObjects;

            var type = 'enterend';
            onEnterEnd && onEnterEnd({ type: type, component: component, matchObjects: matchObjects, hiddenObjects: hiddenObjects });
            return true;
        }
    }, {
        key: '_onLeaveStart',
        value: function _onLeaveStart(objectKey) {
            var component = this._getComponentRef(objectKey);
            if (!component) {
                return false;
            }
            this._componentAnimationFrames[objectKey] = null;
            this._componentStates[objectKey] = 'leave';
            component.isComponentMounted && component.componentWillLeave && component.componentWillLeave(this._onTransitionCallback.bind(this, '_onLeaveComplete', objectKey));

            var onLeaveStart = this.props.onLeaveStart;
            var _state4 = this.state,
                matchObjects = _state4.matchObjects,
                hiddenObjects = _state4.hiddenObjects;

            var type = 'leavestart';
            onLeaveStart && onLeaveStart({ type: type, component: component, matchObjects: matchObjects, hiddenObjects: hiddenObjects });
            return true;
        }
    }, {
        key: '_onLeaveComplete',
        value: function _onLeaveComplete(objectKey) {
            var component = this._getComponentRef(objectKey);
            if (!component) {
                return false;
            }
            this._componentStates[objectKey] = null;
            component.isComponentMounted && component.componentDidLeave && component.componentDidLeave();

            this._setComponentRef(objectKey, null);
            var objectIndex = this.state.hiddenKeys.indexOf(objectKey);
            var hiddenObjects = this.state.hiddenObjects.slice();
            var hiddenKeys = this.state.hiddenKeys.slice();
            hiddenObjects.splice(objectIndex, 1);
            hiddenKeys.splice(objectIndex, 1);
            this.setState({
                hiddenObjects: hiddenObjects,
                hiddenKeys: hiddenKeys
            });

            var onLeaveEnd = this.props.onLeaveEnd;
            var matchObjects = this.state.matchObjects;

            var type = 'leaveend';
            onLeaveEnd && onLeaveEnd({ type: type, component: component, matchObjects: matchObjects, hiddenObjects: hiddenObjects });
            return true;
        }
    }]);

    return TransitionSwitch;
}(Switch);

export default TransitionSwitch;


TransitionSwitch.propTypes = {
    childLimit: PropTypes.number,
    transitionOnAppear: PropTypes.bool,
    errorComponent: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    initialError: PropTypes.any,
    onUriChange: PropTypes.func,
    onError: PropTypes.func,
    onEnterStart: PropTypes.func,
    onEnterEnd: PropTypes.func,
    onLeaveStart: PropTypes.func,
    onLeaveEnd: PropTypes.func
};

TransitionSwitch.defaultProps = {
    childLimit: 1,
    transitionOnAppear: false
};